# classes/phing/types/selectors/SizeSelector.php

Selector that filters files based on their size.

author
  Hans Lellelid <hans@xmpl.org> (Phing)
author
  Bruce Atherton <bruce@callenish.com> (Ant)
package
  phing.types.selectors

## \SizeSelector
jump to top

Selector that filters files based on their size.

It provides support for gathering the parameters together as well as for assigning an error message and throwing a build exception if an error is detected.

Extends from
  \BaseExtendSelector
author
  Hans Lellelid <hans@xmpl.org> (Phing)
author
  Bruce Atherton <bruce@callenish.com> (Ant)
package
  phing.types.selectors
version
  $Revision: 526 $

### Constants

`SIZE_KEY = 'value'`

`UNITS_KEY = 'units'`

`WHEN_KEY = 'when'`

### Properties

`$byteUnits= 'array'`
static
Default value `array` Details

Type

`$cmp= '2'`
Default value `2` Details

Type

`$multiplier= '1'`
Default value `1` Details

Type

`$size= ''`
Details

Type

`$sizeComparisons= 'array'`
static
Default value `array` Details

Type

`$sizelimit= ''`
Details

Type

### Methods

`isSelected( \basedir $basedir, \filename $filename, \file $file ) : \whether`
The heart of the matter. This is where the selector gets to decide on the inclusion of a file in a particular fileset.
Parameters

Name | Type | Description
--- | --- | ---
$basedir | \basedir | A PhingFile object for the base directory
$filename | \filename | The name of the file to check
$file | \file | A PhingFile object for this filename

Returns

Type | Description
--- | ---
\whether |

`setParameters( \parameters $parameters ) :`
When using this as a custom selector, this method will be called.

It translates each parameter into the appropriate setXXX() call.

Parameters

Name | Type | Description
--- | --- | ---
$parameters | \parameters | the complete set of parameters for this selector

`setUnits( \$units $units ) : void`
Sets the units to use for the comparison. This is a little complicated because common usage has created standards that play havoc with capitalization rules. Thus, some people will use "K" for indicating 1000's, when the SI standard calls for "k". Others have tried to introduce "K" as a multiple of 1024, but that falls down when you reach "M", since "m" is already defined as 0.001.

<

p> To get around this complexity, a number of standards bodies have proposed the 2^10 standard, and at least one has adopted it. But we are still left with a populace that isn't clear on how capitalization should work.

<

p> We therefore ignore capitalization as much as possible. Completely mixed case is not possible, but all upper and lower forms are accepted for all long and short forms. Since we have no need to work with the 0.001 case, this practice works here.

<

p> This function translates all the long and short forms that a unit prefix can occur in and translates them into a single multiplier.

Parameters

Name | Type | Description
--- | --- | ---
$units | \$units | The units to compare the size to.

`setValue( \size $size ) :`
A size selector needs to know what size to base its selecting on.

This will be further modified by the multiplier to get an actual size limit.

Parameters

Name | Type | Description
--- | --- | ---
$size | \size | the size to select against expressed in units

`setWhen( \cmp $cmp ) :`
This specifies when the file should be selected, whether it be when the file matches a particular size, when it is smaller, or whether it is larger.
Parameters

Name | Type | Description
--- | --- | ---
$cmp | \cmp | The comparison to perform, an EnumeratedAttribute

`toString( ) :`
`verifySettings( ) :`

Checks to make sure all settings are kosher. In this case, it means that the size attribute has been set (to a positive value), that the multiplier has a valid setting, and that the size limit is valid. Since the latter is a calculated value, this can only fail due to a programming error.

If a problem is detected, the setError() method is called.

Documentation was generated by DocBlox 0.13.1.